' Prsentationssteuerung
' (c) 2009 by meile.biz IT solutions, CH-8247 Flurlingen
' Optimiert fr Logitech-Powerpoint-USB-Fernbedienung

' 19.03.2009: fr Compilier optimiert => damit kann Pfad mit CALL INTERRUPT
' ermittelt werden und ausserdem das Ganze CPU-multitaskingfreundlich

' Dieses Programm ist freie Software und wird unter GNU GPL verteilt
' Bestimmungen siehe http://www.gnu.org/licenses/gpl-3.0.txt

' $INCLUDE: 'qb.bi'

DECLARE SUB ZeigeStatus (f%, t$)
DECLARE SUB ZeigeFernbedientexte (lo$, ro$, lu$, ru$)

DIM bef$(1 TO 20), zi$(9, 3), dosIntEin AS RegTypeX, dosIntAus AS RegTypeX
DIM pfad AS STRING * 300

FOR i% = 0 TO 3
	FOR j% = 0 TO 9
		READ zi$(j%, i%)
	NEXT j%
NEXT i%

' fr Pseudo-Umgebungsvariable %PWD%: aktueller Pfad bestimmen

' Aktuelles Laufwerk holen
dosIntEin.ax = &H1900
CALL INTERRUPTX(&H21, dosIntEin, dosIntAus)
laufw% = dosIntAus.ax AND 255

' Aktueller Pfad holen (Langer Dateiname)
dosIntEin.ax = &H7147
dosIntEin.dx = laufw% + 1
dosIntEin.ds = VARSEG(pfad)
dosIntEin.si = VARPTR(pfad)
CALL INTERRUPTX(&H21, dosIntEin, dosIntAus)
IF dosIntAus.flags AND 1 THEN
	pf$ = ""
ELSE
	p% = INSTR(pfad, CHR$(0))
	IF p% > 0 THEN
		pf$ = LEFT$(pfad, p% - 1)
	ELSE
		pf$ = pfad
	END IF
END IF
IF pf$ = SPACE$(LEN(pf$)) THEN
	' Kein LFN-Supprt (NT 4.0) -> Kurzpfad ermitteln
	dosIntEin.ax = &H4700
	dosIntEin.dx = laufw% + 1
	dosIntEin.ds = VARSEG(pfad)
	dosIntEin.si = VARPTR(pfad)
	CALL INTERRUPTX(&H21, dosIntEin, dosIntAus)
	IF dosIntAus.flags AND 1 THEN
		PRINT "Fehler beim Pfad ermitteln: "; dosIntAus.ax
		END
	ELSE
		p% = INSTR(pfad, CHR$(0))
		IF p% > 0 THEN
			pf$ = LEFT$(pfad, p% - 1)
		ELSE
			pf$ = pfad
		END IF
	END IF
END IF

anzPrae% = 0
OPEN "inhalt.txt" FOR INPUT AS 1
WHILE NOT EOF(1)
	anzPrae% = anzPrae% + 1
	LINE INPUT #1, bef$(anzPrae%)
WEND
CLOSE 1

DATA "", "  ", "", "", "   ", "", "", "", "", ""
DATA "  ", "   ", "  ", "  ", "   ", " ", "  ", "  ", "", "  "
DATA "  ", "   ", "  ", "   ", "", "   ", "  ", "   ", "  ", " "
DATA "", "   ", "", "", "   ", "", "", "   ", "", ""

COLOR 7, 0
CLS
COLOR 3
LOCATE 1, 5
PRINT "Prsentationssteuerung fr Logitech Cordless 2.4 GHz Presenter(TM) V1.0"
LOCATE 2, 14
PRINT "(c) 2009 by meile.biz IT solutions, CH-8247 Flurlingen"

COLOR 7
LOCATE 4, 30
PRINT "Aktuelle Prsentation:"
LOCATE 13
PRINT TAB(34); "Ŀ"
PRINT TAB(34); "F5/Esc  "
PRINT TAB(34); "          "
PRINT TAB(34); ""
PRINT TAB(32); "Ŀ"
PRINT TAB(32); "   /        \   "
PRINT TAB(32); "  <        >  "
PRINT TAB(32); "   \   ";
COLOR 4
PRINT "*";
COLOR 7
PRINT "   /   "
PRINT TAB(32); ""
aktPr% = 1
drin% = -1
WHILE drin%
	a% = aktPr%
	FOR i% = 0 TO 1
		z% = a% MOD 10
		FOR j% = 0 TO 3
			LOCATE 6 + j%, 41 - 5 * i%
			PRINT zi$(z%, j%);
		NEXT j%
		a% = a% \ 10
	NEXT i%
	ZeigeStatus 7, bef$(aktPr%)
	ZeigeFernbedientexte "Beenden", "Starten", "Auswhlen", "Auswhlen"
	DO
		t$ = INKEY$
		' Schonung CPU
		dosIntEin.ax = &H1680
		CALL INTERRUPTX(&H2F, dosIntEin, dosIntAus)
	LOOP WHILE t$ = ""
	SELECT CASE t$
	CASE CHR$(0) + "Q"
		aktPr% = aktPr% MOD anzPrae% + 1
	CASE CHR$(0) + "I"
		aktPr% = (aktPr% + anzPrae% - 2) MOD anzPrae% + 1
	CASE "."
		ZeigeStatus 10, "Prsentation wird abgespielt.."
		' %PWD% ersetzen
		i% = 1
		h$ = ""
		DO
			j% = INSTR(i%, bef$(aktPr%), "%PWD%")
			IF j% > 0 THEN
				h$ = h$ + MID$(bef$(aktPr%), i%, j% - i%) + CHR$(65 + laufw%) + ":\" + pf$
				i% = j% + 5
			END IF
		LOOP WHILE j% > 0
		OPEN ENVIRON$("TEMP") + "\~zeig_pr.bat" FOR OUTPUT AS 1
		PRINT #1, "@" + h$ + MID$(bef$(aktPr%), i%) + " >" + ENVIRON$("TEMP") + "\~OUT.TXT 2>" + ENVIRON$("TEMP") + "\~ERR.TXT"
		CLOSE 1
		SHELL "cmd /c " + ENVIRON$("TEMP") + "\~zeig_pr.bat"
		KILL ENVIRON$("TEMP") + "\~zeig_pr.bat"
		aktPr% = aktPr% MOD anzPrae% + 1
		' Puffer leeren, da sonst evtl. unerwnschtes Starten
		WHILE INKEY$ <> ""
		WEND
	CASE CHR$(0) + "?", CHR$(27)
		ZeigeStatus 12, "Beenden?"
		ZeigeFernbedientexte "Nein", "Ja", "", ""
		drin2% = -1
		WHILE drin2%
			DO
				t$ = INKEY$
				' Schonung CPU
				dosIntEin.ax = &H1680
				CALL INTERRUPTX(&H2F, dosIntEin, dosIntAus)
			LOOP WHILE t$ = ""
			SELECT CASE t$
			CASE CHR$(0) + "?", CHR$(27)
				drin2% = 0
			CASE "."
				drin% = 0
				drin2% = 0
			CASE ELSE
				BEEP
			END SELECT
		WEND
	CASE ELSE
		BEEP
	END SELECT
WEND

CLS
PRINT "Prsentationssteuerung beendet"
END

SUB ZeigeFernbedientexte (lo$, ro$, lu$, ru$)
	COLOR 14
	LOCATE 14, 2
	PRINT SPACE$(31 - LEN(lo$)) + lo$;
	LOCATE , 49
	PRINT ro$ + SPACE$(31 - LEN(ro$));
	LOCATE 18, 2
	PRINT SPACE$(29 - LEN(lu$)) + lu$;
	LOCATE , 52
	PRINT ru$ + SPACE$(28 - LEN(ru$));
	COLOR 7
END SUB

SUB ZeigeStatus (f%, t$)
	COLOR f%
	LOCATE 11, 3
	IF LEN(t$) > 76 THEN
		PRINT ".."; RIGHT$(t$, 74);
	ELSE
		h% = (76 - LEN(t$)) \ 2
		PRINT SPACE$(h%) + t$ + SPACE$(76 - h% - LEN(t$));
	END IF
	COLOR 7
END SUB

